// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "MapEdit03.h"
#include "ChildView.h"
#include <math.h>
#include "Winuser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
num_texture=0;
max_texture_number=30;
angle=50;
pos_x=400;
pos_y=512;
texture_table[0].load_texture("bitmap00.tex");
texture_table[1].load_texture("bitmap01.tex");	
texture_table[2].load_texture("bitmap02.tex");
texture_table[3].load_texture("bitmap03.tex");
texture_table[4].load_texture("bitmap04.tex");	
texture_table[5].load_texture("bitmap05.tex");

}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}


/*
Wykonuje si za kadym razem gdy trzeba odwierzy ekran, np po minimalizacji,
zatem trzeba odrysowac wszystko
*/
void CChildView::OnPaint() 
{
	
	CPaintDC dc(this); 
	int i;	// do iteracji
	/* obwodka do projekcji */
	CDC *pDC=GetDC();
	rysuj_linie(320,10,642,10,pDC);
	rysuj_linie(320,211,642,211,pDC);
	rysuj_linie(320,10,320,211,pDC);	
	rysuj_linie(641,10,641,211,pDC);	
	CPen lpen(PS_SOLID, 1, RGB(190,190,190)); // Wybranie stylu kreski
	pDC->SelectObject(&lpen);
	
	
	//Jakas Ramka
	pDC->SetTextColor(RGB(200,200,200));
	pDC->TextOut(350,230,"Position");
	pDC->TextOut(510,230,"Texture");
	for(i=1;i<18;i++) rysuj_linie(i*15,15,i*15,255,pDC);
	for(i=1;i<18;i++) rysuj_linie(15,i*15,255,i*15,pDC);
	draw_texture(num_texture);
	OnKeyDown(1,1,1);
	ReleaseDC(pDC);
	draw_map();
}

/*
Funkcja do rysowania kresek
na wskazanym obiekcie (_dc) klasy CPaintDC
*/
void CChildView::rysuj_linie(int x1,int y1,int x2, int y2,CDC * _pDC)
{

	_pDC->MoveTo(x1,y1);
	_pDC->LineTo(x2,y2);
}



void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

float kat;

	CDC* pDC=GetDC();
	pDC->SetPixel(int(15+15*(pos_x/64)),int(255-15*(pos_y/64)),RGB(255,155,155));

	if(nChar==39) // Prawo
		{
		
		angle-=1;  
		if(angle==-1) angle=359;
		}
	if(nChar==37)    // lewo
		{
		angle+=1;
		if(angle==360) angle=0;
	 	}
	
	kat=float(3.14159/180*angle);
	if(nChar==38) 	 // gora
	{
		
		pos_x+=float(5*cos(kat));
		pos_y+=float(5*sin(kat));
		//pos_x+=10;
	}
	
	if(nChar==40) 	 // dol
	{
		pos_x-=float(5*cos(kat));
		pos_y-=float(5*sin(kat));
	
	}
	
	if(nChar==33) 	 // PgUp
	{
	if (num_texture<max_texture_number-1)
		{
		num_texture++;
		draw_texture(num_texture);
		}
	
	}
	
	if(nChar==34) 	 // PgDn
	{
	if (num_texture>=0)
		{
		num_texture--;
		draw_texture(num_texture);
		}
	
	}

	pDC->SetPixel(int(15+15*(pos_x/64)),int(255-15*(pos_y/64)),RGB(155,0,0));
	
	moj_ray.ray_casting(int(pos_x),int(pos_y),angle,15000);
	rysuj_scene();

	ReleaseDC(pDC);
	CWnd ::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChildView::rysuj_scene()
{
CDC* pDC=GetDC();
CDC myDC;
myDC.CreateCompatibleDC( pDC );
CBitmap bmp;
bmp.CreateCompatibleBitmap( pDC, 320, 200 );
/*CBitmap* pOldBmp =*/ myDC.SelectObject( &bmp );

int i,j;
int top,bottom;	//poczatek i koniec rysowanego paska
char conv[10];	//do wyswietlania wartosci liczbowych

int dl_paska;	
int kolumna_bmp;
float skala;
COLORREF color;

// Narysowanie tla projekcji	
	CPen lpen(PS_SOLID, 1, RGB(190,190,190)); // Wybranie stylu kreski 
	CPen lpen2(PS_SOLID, 1, RGB(130,130,130)); // Wybranie 2 stylu kreski
	
	myDC.SelectObject(&lpen);
	for(i=0;i<100;i++) rysuj_linie(0,i,320,i,&myDC);
	myDC.SelectObject(&lpen2);
	for(i=100;i<200;i++) rysuj_linie(0,i,320,i,&myDC);

j=0;

// Teksturowanie
	for(i=0;i<320;i++) 
	{
	top=100-int(moj_ray.dist_array[i]/2);
		bottom=top+int(moj_ray.dist_array[i]);
	//skala=64.0/dl_paska;
	skala=float(64.0/moj_ray.dist_array[i]);
	kolumna_bmp=moj_ray.bound_array[i];

	if((dl_paska=int(moj_ray.dist_array[i]))<201)
	for(j=0;j<dl_paska;j++) 
		{
		color=texture_table[moj_ray.marked_texture[i]-1].bitmap[kolumna_bmp][int(skala*(j))] ;
		myDC.SetPixel(i,j+top,color);
		}
	else
		for(j=-top;j<200-top;j++)  //teksturowanie z obcieciem
		{
		color=texture_table[moj_ray.marked_texture[i]-1].bitmap[kolumna_bmp][int(skala*(j))] ;
		myDC.SetPixel(i,j+top,color);
		}
	
		
	
	}
//wyswietlenie zmiennych
sprintf(conv,"%4d",angle);
(*pDC).TextOut(400,260,conv);
(*pDC).TextOut(350,280,'x');
sprintf(conv,"%3f",pos_x);
(*pDC).TextOut(400,280,conv);
sprintf(conv,"%3f",pos_y);
(*pDC).TextOut(400,300,conv);
(*pDC).TextOut(350,300,'y');

//wyswietlenie przygotowanego obrazu projekcji
pDC->BitBlt(321,11,320,200,&myDC,0,0,SRCCOPY );
ReleaseDC(pDC);
myDC.DeleteDC();
lpen.DeleteObject();
lpen2.DeleteObject();
bmp.DeleteObject();
}

void CChildView::draw_texture(int _number)
{
char temp[5];
CDC *pDC=GetDC();
if (_number>=0)
for (int i=0;i<64;i++)
for (int j=0;j<64;j++) pDC->SetPixel(550+i,250+j,texture_table[_number].bitmap[i][j]);
else
	for (int i=0;i<64;i++)
	for (int j=0;j<64;j++) pDC->SetPixel(550+i,250+j,RGB(255,255,255));

sprintf(temp,"%3d",_number+1);
pDC->TextOut(590,230,temp);
ReleaseDC( pDC );
}



void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{

int i,j;
if ((point.x>15)&&(point.x<255)&&(point.y>15)&&(point.y<255))
{
i=point.x/15-1;
j=point.y/15-1;
moj_ray.world[j][i]=num_texture+1;
draw_map();
}	

CWnd ::OnLButtonDown(nFlags, point);
}


void CChildView::draw_map()
{
CDC* pDC=GetDC();
CFont myfont;
myfont.CreateFont(8,4,0,0,0,0,0,0,0,0,0,0,0,"Arial");
pDC->SelectObject(&myfont);
int i,j;
char temp[5];
for (i=0;i<16;i++)
for (j=0;j<16;j++)
	{	
	if (moj_ray.world[j][i]!=0) 
	{
	sprintf(temp,"%d",moj_ray.world[j][i]);
	pDC->TextOut(15*i+15+5,15*j+15+4,temp);
	}
	else draw_square(15*i+15,15*j+15,pDC);
	}
	ReleaseDC(pDC);
DeleteObject(myfont);
}

void CChildView::draw_square(int _x, int _y,CDC *_pDC)
{

	for (int i=1;i<15;i++)
	for (int j=1;j<15;j++)
		_pDC->SetPixel(_x+i,_y+j,RGB(255,255,255));
}
